Wildfire - Amazon Top Interview Questions


Problem Statement :


You are given a two-dimensional integer matrix representing a forest where a cell is:

0 if it's empty
1 if it's a tree
2 if it's a tree on fire
Every day, a tree catches fire if there is an adjacent (top, down, left, right) tree that's also on fire. Return the number of days it would take for every tree to be on fire. If it's not possible, return -1.

Constraints

0 ≤ n * m ≤ 200,000 where n and m are the number of rows and columns in matrix

Example 1

Input

matrix = [
    [1, 1, 1],
    [1, 2, 1],
    [1, 1, 1]
]

Output

2

Explanation

On the first day fire will spread to everywhere except the corner trees and then the next day they will spread to the corner trees.

Example 2

Input

matrix = [
    [1, 1, 1],
    [0, 0, 0],
    [1, 2, 1]
]

Output

-1

Explanation

Fire on bottom row can't move across the middle row because it's empty.



Solution :



title-img




                        Solution in C++ :

int solve(vector<vector<int>>& matrix) {
    int n = matrix.size();
    if (n == 0) return 0;
    int m = matrix[0].size();
    int total = 0;

    queue<pair<int, int>> q;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (matrix[i][j] != 0) total++;
            if (matrix[i][j] == 2) q.push({i, j});
        }
    }

    int dir[5] = {0, -1, 0, 1, 0};
    int cnt = 0, days = 0;
    while (!q.empty()) {
        int sz = q.size();
        cnt += sz;

        for (int j = 0; j < sz; j++) {
            int cx = q.front().first;
            int cy = q.front().second;
            q.pop();

            for (int i = 0; i < 4; i++) {
                int nx = cx + dir[i];
                int ny = cy + dir[i + 1];

                if (nx < 0 || ny < 0 || nx >= n || ny >= m || matrix[nx][ny] != 1) continue;
                matrix[nx][ny] = 2;
                q.push({nx, ny});
            }
        }
        if (!q.empty()) days++;
    }
    return (cnt == total) ? days : -1;
}
// TC :O(N*M), SC :O(N*M)
                    




                        Solution in Python : 
                            
class Solution:
    def solve(self, matrix):
        # basic check
        if matrix == []:
            return 0

        # initialization of the variables
        n, m, dist = len(matrix), len(matrix[0]), 0

        # filling the queue with all the trees which are already on fire
        d = deque((i, j, dist) for i in range(n) for j in range(m) if matrix[i][j] == 2)
        dirs = [(0, 1), (1, 0), (0, -1), (-1, 0)]

        # performing bfs
        while d:
            i, j, dist = d.popleft()
            for x, y in dirs:
                r, c = i + x, j + y
                if 0 <= r < n and 0 <= c < m and matrix[r][c] == 1:
                    d.append((r, c, dist + 1))
                    # print('burnt matrix[{}][{}]'.format(r,c),'on day ',dist+1)
                    matrix[r][c] = 0

        # checking if any tree is left unburnt
        for i in range(n):
            for j in range(m):
                if matrix[i][j] == 1:
                    return -1
        return dist
                    


View More Similar Problems

Queue using Two Stacks

A queue is an abstract data type that maintains the order in which elements were added to it, allowing the oldest elements to be removed from the front and new elements to be added to the rear. This is called a First-In-First-Out (FIFO) data structure because the first element added to the queue (i.e., the one that has been waiting the longest) is always the first one to be removed. A basic que

View Solution →

Castle on the Grid

You are given a square grid with some cells open (.) and some blocked (X). Your playing piece can move along any row or column until it reaches the edge of the grid or a blocked cell. Given a grid, a start and a goal, determine the minmum number of moves to get to the goal. Function Description Complete the minimumMoves function in the editor. minimumMoves has the following parameter(s):

View Solution →

Down to Zero II

You are given Q queries. Each query consists of a single number N. You can perform any of the 2 operations N on in each move: 1: If we take 2 integers a and b where , N = a * b , then we can change N = max( a, b ) 2: Decrease the value of N by 1. Determine the minimum number of moves required to reduce the value of N to 0. Input Format The first line contains the integer Q.

View Solution →

Truck Tour

Suppose there is a circle. There are N petrol pumps on that circle. Petrol pumps are numbered 0 to (N-1) (both inclusive). You have two pieces of information corresponding to each of the petrol pump: (1) the amount of petrol that particular petrol pump will give, and (2) the distance from that petrol pump to the next petrol pump. Initially, you have a tank of infinite capacity carrying no petr

View Solution →

Queries with Fixed Length

Consider an -integer sequence, . We perform a query on by using an integer, , to calculate the result of the following expression: In other words, if we let , then you need to calculate . Given and queries, return a list of answers to each query. Example The first query uses all of the subarrays of length : . The maxima of the subarrays are . The minimum of these is . The secon

View Solution →

QHEAP1

This question is designed to help you get a better understanding of basic heap operations. You will be given queries of types: " 1 v " - Add an element to the heap. " 2 v " - Delete the element from the heap. "3" - Print the minimum of all the elements in the heap. NOTE: It is guaranteed that the element to be deleted will be there in the heap. Also, at any instant, only distinct element

View Solution →